= Amrita2 -  a xml/xhtml template library for Ruby

== Summary

Amrita2 is a a xml/xhtml template library for Ruby. 
It makes html documents from a template and a model data.

=== Key feature

template:

--- xmlinline 
      # 
       <table border="1">                      
         <tr><th>name</th><th>author</th></tr> 
         <tr id="table1">                        
           <td id="name" /><td id="author" />      
         </tr>                                 
       </table>                                
   
data:

--- rubyinline 
      # 
         data = {                                               
            :table1=>[                                          
               { :name=>"Ruby", :author=>"matz" },              
               { :name=>"perl", :author=>"Larry Wall" },        
               { :name=>"python", :author=>"Guido van Rossum" },
            ]                                                   
         }                                                      
      
template + data = output:
 
--- xmlinline 
      # 
        <table>                    
          <tr>                     
          <th>name</th>            
          <th>author</th>          
          </tr>                    
          <tr>                     
          <td>Ruby</td>            
          <td>matz</td>            
          </tr>                    
          <tr>                     
          <td>perl</td>            
          .......

* The template for amrita2 is a pure html/xhtml document without no
  special tag like <?...?> or <% .. %>

* The template can be written by designers using almost any xhtml/xml
  Editor.

* Need no change on Ruby code to change the view of _dynamic_ part
  (not only static part) of the template

* The model data may be standard Ruby data, Hash, Array, String... or
  an instance of a classes you made.

* The output is controlled by _data_ not by logic. So It's easy to
  write, test, debug code. (Good for eXtreamPrograming)

Amrita2 mixes a template and model data up to a html document naturally
matching the +id+ attribute of XML element to model data.

=== New Features 

* Amrita2-Rails bridge and many support for Ruby On Rails 
* can use ERB for some elements in Amrita2 template
* It is an XHTML to Ruby compiler, so optimazation for speed is easier than 1.0
* option for special expansion for a special tag like <a> <input> <input type='checkbox'> <tl> <select>...
  in other words, more natural transformation from data to output.
* templates need not have id attributes
* A2TDL(Amrita2 Template Definition Language): Builder type API with many useful macros
* ReverseEngineering(Experimental)
* JavaScript template(Experimental)

=== Current version and roadmap

Current version is 1.9.5 and
roadmap is ((<here|URL:http://rubyforge.org/pipermail/amrita2-users/2005-May/000000.html>)).


== mailing list

* ((<Amrita2-users info Page|URL:http://rubyforge.org/mailman/listinfo/amrita2-users>))

== Download

* ((<Rubyforge project page|URL:http://rubyforge.org/projects/amrita2>))

== Online Documents 

* ((<Quick Start Guide|URL:QuickStart.html>)) (((<Japanese|URL:QuickStartJ.html>)))
* ((<How to use Amrita2 with Ruby On Rails|URL:Rails.html>))
* ((<Using Template Spec|URL:Spec.html>))
* ((<A2TDL|URL:A2TDL.html>))
* ((<Reverse Engineering|URL:Reverse.html>)) ( Generate a Ruby code from XHTML document)
* ((<internals and active po methods|URL:active_po.html>))
* ((<JavaScript Template|URL:js.html>))


* ((<ChangeLog|URL:ChangeLog>))

== sample source

* ((<hello world and simple samples|URL:http://amrita2.rubyforge.org/hello/index.html>))
* ((<using rails|URL:http://amrita2.rubyforge.org/rails/index.html>))
* ((<using template spec|URL:http://amrita2.rubyforge.org/spec/index.html>))
* ((<using JavaScript template|URL:http://amrita2.rubyforge.org/js/index.html>))

== License

Amrita2 is Copyright (c) 2005 Taku Nakajima
<tnakajima@brain-tokyo.jp>.  It is free software, and may be
redistributed under the terms specified in the README file of the Ruby
distribution.

