$: << File::expand_path("~/amrita2/lib")

require 'amrita2/template'
require 'amrita2/a2tdl'

require 'stringio'

module Amrita2View

  class Base
    @@compiled_amrita2_templates = {}

    def initialize( action_view )
      @action_view = action_view
    end

    def render( template, local_assigns={} )
      action_name = @action_view.controller.action_name
      tmpl_method = action_name + "_setup_template"
      
      tmpl = @@compiled_amrita2_templates[template] ||= 
        if @action_view.respond_to?(tmpl_method)
          @action_view.send(tmpl_method, template)
        else
          #STDOUT.puts 'compiling'
          Amrita2::TemplateText.new(template)
        end

      po_method = action_name + "_po"
      po = if @action_view.respond_to?(po_method)
             @action_view.send(po_method)
           else
             @action_view.controller
           end             

      out = StringIO.new
      tmpl.expand(out, po)
      out.string
    rescue
      $!.to_s + $@.join("<br>")
    end

  end

end

module Amrita2TDLView
  class Base
    include Amrita2

    def initialize( action_view )
      @action_view = action_view
    end

    def render(tdl, local_assigns={} )
      #STDOUT.puts tdl
      template = Amrita2::Template.new do 
        eval tdl
      end
      template.setup
      #STDOUT.puts template.spec.inspect
      out = StringIO.new
      action_name = @action_view.controller.action_name

      po_method = action_name + "_po"
      po = if @action_view.respond_to?(po_method)
             STDOUT.puts 'view'
             @action_view.send(po_method)
           else
             STDOUT.puts 'controler'
             @action_view.controller
           end             

      template.expand(out, po)
      
      #STDOUT.puts out.string
      out.string
    rescue Exception
      STDOUT.puts $!
      $!.to_s + $@.join("<br>")
    end

  end

end
