#!/usr/bin/env ruby

$: << '/home/tnaka/amrita2/lib'

require 'cgi'
require 'amrita2/template'
require 'amrita2/a2tdl'


t = Amrita2::Template.new do 
  Amrita2::define_template_spec do 
    html do 
      title('Amrita2 CGI and HTML generator sample')
      grid_form(:f1, :buttons=>[:ok, :preview], :action=>'') do 
        text_field(:name)
        password_field(:pass)
        check_box(:amrita2_user)
        select(:lang, :description=>'programing language') do |s|
          s.opt(:ruby, 'Ruby')
          s.opt(:perl, 'Perl')
          s.opt(:java, 'Java')
          s.opt(:cpp, 'C++')
        end
        radio_buttons(:license) do |s|
          s.opt(:gpl, 'gpl')
          s.opt(:bsd, 'bsd')
          s.opt(:ruby, "Ruby")
        end
        textarea(:comment, :html_attr=>{ :cols=>30 })
      end
      hr
      H2('result')
      span(:result)
    end
  end
end

cgi = CGI.new

form = { 
  :name => '',
  :pass => '',
  :amrita2_user=> false,
  :lang => :ruby,
  :license => :gpl,
  :comment => ''
}

cgi.keys.each do |k|
  form[k.intern] = cgi[k]
end.join

result = cgi.keys.collect do |k|
  "#{k}=#{cgi[k]}/"
end.join

puts cgi.header
t.expand(STDOUT, :f1 => form, :result => result)

