require 'dialog'

class FileListDialog < Dialog
  class LS
    def initialize(opt)
      @opt = opt
    end

    def option
      opt = ["-l"]
      opt << '-t ' if @opt[:time]
      case @opt[:time_type]
      when 'mtime'
      when 'ctime'
        opt << '-c'
      when 'atime'
        opt << '-u'
      end
      opt << '-r' if @opt[:reverse]
      opt.join(' ')
    end

    def result
      p option
      IO::popen("ls #{option}") do |ls|
        ls.gets
        ls.collect do |l|
          a = l.split(/\s+/, 8)
          { 
            :mod => a[0],
            :links => a[1],
            :owner => a[2],
            :group => a[3],
            :size => a[4],
            :date => a[5],
            :time => a[6], 
            :fname => a[7]
          }
        end
      end
    end
  end


  def init_dialog
    define_dialog do
      @time = nil
      init_screen do 
        check_box(:time, :description=>'sort by time')
        select(:time_type) do 
          opt(:mtime)
          opt(:ctime)
          opt(:atime)
        end
        check_box(:reverse, :description=>'reverse sort')
      end.process(:ok) do 
        @result = LS.new(:time=>@time, 
                         :time_type=>@time_type,
                         :reverse=>@reverse).result
        next_screen(:result)
      end

      screen(:result) do 
        simple_table(:result) do 
          column(:mod)
          column(:links, :html_attr=>{ :align => 'right'}) 
          column(:owner)
          column(:group) 
          column(:size, :html_attr=>{ :align => 'right'})
          column(:date)
          column(:time)
          column(:fname)
        end
      end.process(:ok) do 
        init_session
      end
    end
  end
end

if __FILE__ == $0
  httpd = WEBrick::HTTPServer.new({:Port => 12345})
  httpd.mount('/hello', DialogServlet, HelloDialog)
  trap('INT') do
    httpd.shutdown
  end
  trap('TERM') do
    httpd.shutdown
  end
  httpd.start
end
