require 'dialog'

class NumberGameDialog < Dialog
  def init_dialog
    define_dialog do 
      # this variable is shared by all procs
      answer = nil

      # instance variables will be put to screen automatically
      @history = []

      # screen definition
      init_screen(:title=>'Welcom to Number Game') do 
        text_field(:name, :description=>"What's your name")
        text_field(:max, :description=>"Max Number?")
      end.process(:ok) do
        # how to process the response from users
        if @name.to_s == ""
          message('input your name please')
        else
          @max = 10 if @max.to_i < 2
          answer = rand(@max.to_i)
          p answer
          message("try a number 1..#{@max}")
          next_screen(:game) 
        end
      end

      # second screen definition
      screen(:game) do 
        span(:result) # display only field
        text_field(:try, :description=>"Input number")

        # table display from @history
        simple_table(:history) do 
          column(:no)
          column(:try)
          column(:result)
        end
      end.process(:try) do 
        if answer < @try.to_i
          @result = 'HIGH!'
        elsif answer > @try.to_i
          @result = 'LOW!'
        else
          @result = 'HIT'
          message("Congratiation #@name")
          next_screen(:hit) 
        end
        @history << { 
          :no => @history.size + 1,
          :try => @try,
          :result=> @result
        }
      end.process(:give_up) do
        # cascade processes if you need many buttons 
        init_session
      end

      screen(:hit) do 
        simple_table(:history) do 
          column(:no)
          column(:try)
          column(:result)
        end
      end.process(:ok) do
        init_session
      end

      # this will be inserted to all screens
      common_area(:top) do 
        a('index', :html_attr=>{ :href=>"/"} )
        span(' / ')
        a('source of this demo', :html_attr=>{ :href=>"/number.rb.txt"} )
        span(' / ')
        a('source of dialog system', :html_attr=>{ :href=>"/dialog.rb.txt"} )
      end
      common_area(:bottom) do 
        span('powerd by ')
        a('Amrita2', :html_attr=>{ :href=>"http://amrita2.rubyforge.org"} )
      end
    end
  end
end

if __FILE__ == $0
  httpd = WEBrick::HTTPServer.new({:Port => 12345})
  httpd.mount('/number', DialogServlet, NumberGameDialog)
  trap('INT') do
    httpd.shutdown
  end
  trap('TERM') do
    httpd.shutdown
  end
  httpd.start
end
