require 'dialog'

class OrderDemoDialog < Dialog
  def init_dialog
    define_dialog do

      init_screen do 
        text_field(:email)
        radio_buttons(:regist) do 
          opt(:new, 'new customer')
          opt(:old, 'registerd customer')
        end
        password_field(:pass)
      end.process(:ok) do
        if @regist == 'new'
          next_screen(:customer_information)
        else
          if check_password(@email, @pass)
            next_screen(:payment)
          else
            message('password does not match, enter again')
          end
        end
      end

      screen(:customer_information) do 
        text_field(:name)
        password_field(:password)
        password_field(:password2, :description=>'confirm password')
        text_field(:address1, :html_attr=>{ :size=>50 })
        text_field(:address2, :html_attr=>{ :size=>50 })
        select(:country, :description=>'Country(sorry choises are J only now)') do 
          opt(:je, 'Jersey')
          opt(:jm, 'Jamaica')
          opt(:jo, 'Jordan')
          opt(:jp, 'Japan')
        end
      end.process(:ok) do 
        if @name == "" or  @address1 == "" or  @address1 == "" or @country == ""
          message('Input all fiealds')
        elsif @password != @password2
          message('password do not match')
        else
          next_screen(:payment)
        end
      end

      screen(:payment) do 
        radio_buttons(:payment_method) do 
          opt(:visa)
          opt(:mastercard)
          opt(:jcb)
        end
        text_field(:cardno)
        select(:exp_m) do 
          (1..12).each do |m|
            key = 'm' + m.to_s
            opt(key.intern, m)
          end
        end
        select(:exp_y) do 
          (2005..2010).each do |y|
            key = 'y' + y.to_s
            opt(key.intern, y)
          end
        end
        text_field(:cardholder, :description=>"Cardholder's name")
      end.process(:ok) do 
        @addresses = [@name, @address1, @address2, @coutry].join
        @payment_confirm = "#@payment_method #@exp_m/#@exp_y #@cardno #@cardholder"
        next_screen(:confirm)
      end
      
      screen(:confirm) do 
        span(:addresses)
        span(:payment_confirm)
      end.process(:order) do 
        next_screen(:order_comlete)
      end.process(:change_address) do 
        next_screen(:customer_information)
      end.process(:change_payment) do 
        next_screen(:payment)
      end
      

      screen(:order_comlete, :title=>'Order Completed') do 
        span('Thank you')
      end.process(:ok) do 
        init_session
      end

      # this will be inserted to all screens
      common_area(:top) do 
        a('index', :html_attr=>{ :href=>"/"} )
        span(' / ')
        a('source of this demo', :html_attr=>{ :href=>"/order.rb.txt"} )
        span(' / ')
        a('source of dialog system', :html_attr=>{ :href=>"/dialog.rb.txt"} )
      end
      common_area(:bottom) do 
        span('powerd by ')
        a('Amrita2', :html_attr=>{ :href=>"http://amrita2.rubyforge.org"} )
      end
    end
  end

  def check_password(email, pass)
    # dummy logic for demo
    email == pass
  end
end

if __FILE__ == $0
  httpd = WEBrick::HTTPServer.new({:Port => 12345})
  httpd.mount('/order', DialogServlet, OrderDemoDialog)
  trap('INT') do
    httpd.shutdown
  end
  trap('TERM') do
    httpd.shutdown
  end
  httpd.start
end
