
require 'amrita2/core'
require 'amrita2/a2tdl'

module TodoHelper
  include Amrita2
  include Amrita2::Runtime

  def display_item(item)
    { 
      # normal 'dynamic_element' accepts text
      :description=>item.description,
      # 'check_box' accepts Boolean value
      :item_done=>a(:onclick => %[document.location.href="/todo/toggle_check/#{item.id}";]),
      # 'a_link' accepts REXML::Element and a(..) { ... } is shortcut for it
      :edit_link=>a(:href=>"/todo/edit/#{item.id}") { "Edit" },
      # another way for setting attributes dynamically
      :destroy_link => proc do |m|
        msg = "Are you sure you want to delete this entry: #{item.description}"
        onclick=Amrita2::SanitizedString[%[return confirm("#{msg}");]]
        #onclick=''
        m.destroy_link("Destroy", "/todo/destroy/#{item.id}", :onclick=>onclick)
      end
    }
  end

  def list_po
#     ret = { 
#       :done => controller.done.collect do |r|
#         display_item(r)
#       end,
#       :not_done => controller.not_done.collect do |r|
#         display_item(r)
#       end,
#       :form=>binding
#     }

    ret = { :todo_list=>controller.list_po }
    ret[:form] = binding

    #STDOUT.puts ret.inspect
    ret
  end

end

