require "amrita2/template"
include Amrita2
include Amrita2::Runtime # for amrita:type='erb'

TEMPLATE_TEXT = <<END
<html>
   <head>
   <span id='header_title' amrita:type='erb'><![CDATA[
     <title><%= TITLE %></title>
   ]]></span>
   </head>
   <body>
      <span id='title' amrita:type='erb'><![CDATA[
        <h1><%= TITLE + $_ %></h1>
      ]]></span>
      <table>
      <tr><th>name</th><th>author</th></tr>
      <span id='item' amrita:type='erb'><![CDATA[
        <tr>
          <td><%= make_link($_[1], $_[0]) %></td>
          <td><%= $_[2] %></td>
        </tr>
      ]]></span>
      </table>
      <hr />
      <br />
</body>
</html>
END

table = [
  ["Ruby", "http://www.ruby-lang.org/", "Matz"  ],
  ["Perl", "http://www.perl.com/",  "Larry Wall" ],
  ["Python", "http://www.python.org/", "Guido van Rossum"   ]
]

def make_link(url, text)
  "<a href='#{url}'>#{text}</a>"
end
TITLE='Amrita2 with ERB '

# get binding at the place where you can see 'make_link' and 'TITLE '
b = binding 

# and pass the binding to erb item
data = { 
  :header_title => b,
  :title => [b, ' Sample'], # pass an addtional args
  :item=> table.collect { |i| [b, i] }
}
tmpl = TemplateText.new(TEMPLATE_TEXT) 
tmpl.expand(STDOUT, data)

__END__
<html>
   <head>
     <title>Amrita2 with ERB </title>
   </head>
   <body>
        <h1>Amrita2 with ERB  Sample</h1>
      <table>
      <tr><th>name</th><th>author</th></tr>
        <tr>
          <td><a href='http://www.ruby-lang.org/'>Ruby</a></td>
          <td>Matz</td>
        </tr>
        <tr>
          <td><a href='http://www.perl.com/'>Perl</a></td>
          <td>Larry Wall</td>
        </tr>
        <tr>
          <td><a href='http://www.python.org/'>Python</a></td>
          <td>Guido van Rossum</td>
        </tr>
      </table>
      <hr></hr>
      <br></br>
</body>
</html>
