require "amrita2/template"
include Amrita2
include Amrita2::Runtime # for amrita:type='erb'

TEMPLATE_TEXT = <<END
<html>
   <body>
      <table>
      <tr><th>name</th><th>author</th></tr>
      <tr id='lang' amrita:type='use_args'>
         <td><a href='$2'>$1</a></td><td>$3</td>
      </tr>
      </table>
      <hr />
      powered by <a id='link' amrita:type='link'>Amrita2</a>
      <br />
      <span id='erb_time' amrita:type='erb'><![CDATA[
        <small>It is <%= Time.now %> now </small>
      ]]></span>
      <hr />
      <input id='text1' amrita:type='input' name='text1' type='text' />
      <input id='cb1' amrita:type='checkbox' name='cb1' type='checkbox' />
      <select id='sel1' amrita:type='select'>
        <option value='a'>aaa</option>
        <option value='b'>bbb</option>
        <option value='c'>ccc</option> 
      </select>
</body>
</html>
END

table = [
  ["Ruby", "http://www.ruby-lang.org/", "Matz"  ],
  ["Perl", "http://www.perl.com/",  "Larry Wall" ],
  ["Python", "http://www.python.org/", "Guido van Rossum"   ]
]

data = { 
  :lang=>table,
  :link=>'http://amrita2.rubyforge.org/',
  :erb_time =>binding,
  :text1 => 'Input a text here',
  :cb1 => rand(2)%2 == 0,
  :sel1 => ARGV.shift || :a
}
tmpl = TemplateText.new(TEMPLATE_TEXT) 
tmpl.expand(STDOUT, data)

__END__
<html>
   <body>
      <table>
      <tr><th>name</th><th>author</th></tr>
      <tr>
         <td><a href='http://www.ruby-lang.org/'>Ruby</a></td><td>Matz</td>
      </tr><tr>
         <td><a href='http://www.perl.com/'>Perl</a></td><td>Larry Wall</td>
      </tr><tr>
         <td><a href='http://www.python.org/'>Python</a></td><td>Guido van Rossum</td>
      </tr>
      </table>
      <hr></hr>
      powered by <a href='http://amrita2.rubyforge.org/'>Amrita2</a>
      <br></br>

        <small>It is Mon Apr 11 16:12:57 JST 2005 now </small>

      <hr></hr>
      <input name='text1' type='text' value='Input a text here'/>
      <input name='cb1' type='checkbox'/>
      <select>
        <option selected='selected' value='a'>aaa</option>
        <option value='b'>bbb</option>
        <option value='c'>ccc</option>
      </select>
</body>
</html>
